; ModuleID = 'map'
target datalayout = "e-m:o-i64:64-f80:128-n8:16:32:64-S128"
; target triple = "x86_64-apple-darwin15.6.0"
; target triple = "x86_64-unknown-linux-gnu"

; Function Attrs: norecurse nounwind
define void @map(i64 %ix.start, i64 %ix.end, float* noalias nocapture %out.ad0, i64 %out.sh0, float* noalias nocapture readonly %fv0.ad0, i64 %fv0.sh0) local_unnamed_addr #0 {
entry:
  %0 = icmp sgt i64 %ix.end, %ix.start
  br i1 %0, label %while1.top.preheader, label %while1.exit

while1.top.preheader:                             ; preds = %entry
  %1 = sub i64 %ix.end, %ix.start
  %min.iters.check = icmp ult i64 %1, 32
  br i1 %min.iters.check, label %while1.top.preheader9, label %min.iters.checked

min.iters.checked:                                ; preds = %while1.top.preheader
  %n.vec = and i64 %1, -32
  %cmp.zero = icmp eq i64 %n.vec, 0
  %ind.end = add i64 %n.vec, %ix.start
  br i1 %cmp.zero, label %while1.top.preheader9, label %vector.body.preheader

vector.body.preheader:                            ; preds = %min.iters.checked
  br label %vector.body

vector.body:                                      ; preds = %vector.body.preheader, %vector.body
  %index = phi i64 [ %index.next, %vector.body ], [ 0, %vector.body.preheader ]
  %2 = add i64 %index, %ix.start
  %3 = getelementptr float, float* %fv0.ad0, i64 %2
  %4 = bitcast float* %3 to <8 x float>*
  %wide.load = load <8 x float>, <8 x float>* %4, align 4
  %5 = getelementptr float, float* %3, i64 8
  %6 = bitcast float* %5 to <8 x float>*
  %wide.load4 = load <8 x float>, <8 x float>* %6, align 4
  %7 = getelementptr float, float* %3, i64 16
  %8 = bitcast float* %7 to <8 x float>*
  %wide.load5 = load <8 x float>, <8 x float>* %8, align 4
  %9 = getelementptr float, float* %3, i64 24
  %10 = bitcast float* %9 to <8 x float>*
  %wide.load6 = load <8 x float>, <8 x float>* %10, align 4
  %11 = fadd fast <8 x float> %wide.load, <float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00>
  %12 = fadd fast <8 x float> %wide.load4, <float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00>
  %13 = fadd fast <8 x float> %wide.load5, <float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00>
  %14 = fadd fast <8 x float> %wide.load6, <float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00, float 1.000000e+00>
  %15 = getelementptr float, float* %out.ad0, i64 %2
  %16 = bitcast float* %15 to <8 x float>*
  store <8 x float> %11, <8 x float>* %16, align 4
  %17 = getelementptr float, float* %15, i64 8
  %18 = bitcast float* %17 to <8 x float>*
  store <8 x float> %12, <8 x float>* %18, align 4
  %19 = getelementptr float, float* %15, i64 16
  %20 = bitcast float* %19 to <8 x float>*
  store <8 x float> %13, <8 x float>* %20, align 4
  %21 = getelementptr float, float* %15, i64 24
  %22 = bitcast float* %21 to <8 x float>*
  store <8 x float> %14, <8 x float>* %22, align 4
  %index.next = add i64 %index, 32
  %23 = icmp eq i64 %index.next, %n.vec
  br i1 %23, label %middle.block, label %vector.body, !llvm.loop !0

middle.block:                                     ; preds = %vector.body
  %cmp.n = icmp eq i64 %1, %n.vec
  br i1 %cmp.n, label %while1.exit, label %while1.top.preheader9

while1.top.preheader9:                            ; preds = %middle.block, %min.iters.checked, %while1.top.preheader
  %.ph = phi i64 [ %ix.start, %min.iters.checked ], [ %ix.start, %while1.top.preheader ], [ %ind.end, %middle.block ]
  br label %while1.top

while1.top:                                       ; preds = %while1.top.preheader9, %while1.top
  %24 = phi i64 [ %29, %while1.top ], [ %.ph, %while1.top.preheader9 ]
  %25 = getelementptr float, float* %fv0.ad0, i64 %24
  %26 = load float, float* %25, align 4
  %27 = fadd fast float %26, 1.000000e+00
  %28 = getelementptr float, float* %out.ad0, i64 %24
  store float %27, float* %28, align 4
  %29 = add nsw i64 %24, 1
  %exitcond = icmp eq i64 %29, %ix.end
  br i1 %exitcond, label %while1.exit.loopexit, label %while1.top, !llvm.loop !3

while1.exit.loopexit:                             ; preds = %while1.top
  br label %while1.exit

while1.exit:                                      ; preds = %while1.exit.loopexit, %middle.block, %entry
  ret void
}

attributes #0 = { norecurse nounwind }

!0 = distinct !{!0, !1, !2}
!1 = !{!"llvm.loop.vectorize.width", i32 1}
!2 = !{!"llvm.loop.interleave.count", i32 1}
!3 = distinct !{!3, !4, !1, !2}
!4 = !{!"llvm.loop.unroll.runtime.disable"}
